---
title: X-Frame-Options
slug: Web/HTTP/Headers/X-Frame-Options
tags:
  - Gecko
  - HAProxy
  - HTTP
  - Response Header
  - Security
  - nginx
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code>X-Frame-Options</code></strong> <a href="/en-US/docs/Web/HTTP">HTTP</a> response header can be used to indicate whether or not a browser should be allowed to render a page in a {{HTMLElement("frame")}}, {{HTMLElement("iframe")}}, {{HTMLElement("embed")}} or {{HTMLElement("object")}}. Sites can use this to avoid <a href="/en-US/docs/Web/Security/Types_of_attacks#Click-jacking">click-jacking</a> attacks, by ensuring that their content is not embedded into other sites.</p>

<p>The added security is provided only if the user accessing the document is using a browser that supports <code>X-Frame-Options</code>.</p>

<div class="note">
<p><strong>Note:</strong> The {{HTTPHeader("Content-Security-Policy")}} HTTP header has a {{HTTPHeader("Content-Security-Policy/frame-ancestors", "frame-ancestors")}} directive which <a href="https://www.w3.org/TR/CSP2/#frame-ancestors-and-frame-options">obsoletes</a> this header for supporting browsers.</p>
</div>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("Response header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>There are two possible directives for <code>X-Frame-Options</code>:</p>

<pre class="syntaxbox notranslate">X-Frame-Options: DENY
X-Frame-Options: SAMEORIGIN
</pre>

<h3 id="Directives">Directives</h3>

<p>If you specify <code>DENY</code>, not only will attempts to load the page in a frame fail when loaded from other sites, attempts to do so will fail when loaded from the same site. On the other hand, if you specify <code>SAMEORIGIN</code>, you can still use the page in a frame as long as the site including it in a frame is the same as the one serving the page.</p>

<dl>
 <dt><code>DENY</code></dt>
 <dd>The page cannot be displayed in a frame, regardless of the site attempting to do so.</dd>
 <dt><code>SAMEORIGIN</code></dt>
 <dd>The page can only be displayed in a frame on the same origin as the page itself. The spec leaves it up to browser vendors to decide whether this option applies to the top level, the parent, or the whole chain, although it is argued that the option is not very useful unless all ancestors are also in the same origin (see {{bug(725490)}}). Also see {{anch("Browser compatibility")}} for support details.</dd>
 <dt><code>ALLOW-FROM <em>uri</em></code><em> </em>{{obsolete_inline()}}</dt>
 <dd>This is an obsolete directive that no longer works in modern browsers. Don't use it. In supporting legacy browsers, a page can be displayed in a frame only on the specified origin <em>uri</em>. Note that in the legacy Firefox implementation this still suffered from the same problem as <code>SAMEORIGIN</code> did — it doesn't check the frame ancestors to see if they are in the same origin. The {{HTTPHeader("Content-Security-Policy")}} HTTP header has a {{HTTPHeader("Content-Security-Policy/frame-ancestors", "frame-ancestors")}} directive which you can use instead.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<div class="note">
<p><strong>Note:</strong> Setting X-Frame-Options inside the  {{HTMLElement("meta")}} element is useless! For instance, <code>&lt;meta http-equiv="X-Frame-Options" content="deny"&gt;</code> has no effect. Do not use it!  <code>X-Frame-Options</code> works only by setting through the HTTP header, as in the examples below.</p>
</div>

<h3 id="Configuring_Apache">Configuring Apache</h3>

<p>To configure Apache to send the <code>X-Frame-Options</code> header for all pages, add this to your site's configuration:</p>

<pre class="notranslate">Header always set X-Frame-Options "SAMEORIGIN"
</pre>

<p>To configure Apache to set the <code>X-Frame-Options</code> DENY, add this to your site's configuration:</p>

<pre class="notranslate">Header set X-Frame-Options "DENY"
</pre>

<h3 id="Configuring_nginx">Configuring nginx</h3>

<p>To configure nginx to send the <code>X-Frame-Options</code> header, add this either to your http, server or location configuration:</p>

<pre class="notranslate">add_header X-Frame-Options SAMEORIGIN always;
</pre>

<h3 id="Configuring_IIS">Configuring IIS</h3>

<p>To configure IIS to send the <code>X-Frame-Options</code> header, add this to your site's <code>Web.config</code> file:</p>

<pre class="brush: xml notranslate">&lt;system.webServer&gt;
  ...

  &lt;httpProtocol&gt;
    &lt;customHeaders&gt;
      &lt;add name="X-Frame-Options" value="SAMEORIGIN" /&gt;
    &lt;/customHeaders&gt;
  &lt;/httpProtocol&gt;

  ...
&lt;/system.webServer&gt;
</pre>

<p>Or see this <a href="https://support.office.com/en-us/article/Mitigating-framesniffing-with-the-X-Frame-Options-header-1911411b-b51e-49fd-9441-e8301dcdcd79">Microsoft support article on setting this configuration using the IIS Manager</a> user interface.</p>

<h3 id="Configuring_HAProxy">Configuring HAProxy</h3>

<p>To configure HAProxy to send the <code>X-Frame-Options</code> header, add this to your front-end, listen, or backend configuration:</p>

<pre class="notranslate">rspadd X-Frame-Options:\ SAMEORIGIN
</pre>

<p>Alternatively, in newer versions:</p>

<pre class="notranslate">http-response set-header X-Frame-Options SAMEORIGIN
</pre>

<h3 id="Configuring_Express">Configuring Express</h3>

<p>To configure Express to send the <code>X-Frame-Options</code> header, you can use <a href="https://helmetjs.github.io/">helmet</a> which uses <a href="https://helmetjs.github.io/docs/frameguard/">frameguard</a> to set the header. Add this to your server configuration:</p>

<pre class="brush: js notranslate">const helmet = require('helmet');
const app = express();
app.use(helmet.frameguard({ action: 'SAMEORIGIN' }));
</pre>

<p>Alternatively, you can use frameguard directly:</p>

<pre class="brush: js notranslate">const frameguard = require('frameguard')
app.use(frameguard({ action: 'SAMEORIGIN' }))
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC("7034")}}</td>
   <td>HTTP Header Field X-Frame-Options</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.X-Frame-Options")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Content-Security-Policy")}} directive {{HTTPHeader("Content-Security-Policy/frame-ancestors", "frame-ancestors")}}</li>
 <li><a href="https://tools.ietf.org/html/rfc7034">HTTP Header Field X-Frame-Options - RFC 7034</a></li>
 <li><a class="external" href="https://docs.microsoft.com/en-us/archive/blogs/ie/ie8-security-part-vii-clickjacking-defenses">ClickJacking Defenses - IEBlog</a></li>
 <li><a href="https://docs.microsoft.com/en-us/archive/blogs/ieinternals/combating-clickjacking-with-x-frame-options">Combating ClickJacking with X-Frame-Options - IEInternals</a></li>
</ul>
